package com.gxwebsoft.oa.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.oa.service.OaTaskRecordService;
import com.gxwebsoft.oa.entity.OaTaskRecord;
import com.gxwebsoft.oa.param.OaTaskRecordParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.v3.oas.annotations.tags.Tag;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 工单回复记录表控制器
 *
 * @author 科技小王子
 * @since 2024-09-10 20:57:42
 */
@Tag(name = "工单回复记录表管理")
@RestController
@RequestMapping("/api/oa/oa-task-record")
public class OaTaskRecordController extends BaseController {
    @Resource
    private OaTaskRecordService oaTaskRecordService;

    @Operation(summary = "分页查询工单回复记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<OaTaskRecord>> page(OaTaskRecordParam param) {
        // 使用关联查询
        return success(oaTaskRecordService.pageRel(param));
    }

    @Operation(summary = "查询全部工单回复记录表")
    @GetMapping()
    public ApiResult<List<OaTaskRecord>> list(OaTaskRecordParam param) {
        PageParam<OaTaskRecord, OaTaskRecordParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(oaTaskRecordService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(oaTaskRecordService.listRel(param));
    }

    @PreAuthorize("hasAuthority('oa:oaTaskRecord:list')")
    @OperationLog
    @Operation(summary = "根据id查询工单回复记录表")
    @GetMapping("/{id}")
    public ApiResult<OaTaskRecord> get(@PathVariable("id") Integer id) {
        return success(oaTaskRecordService.getById(id));
        // 使用关联查询
        //return success(oaTaskRecordService.getByIdRel(id));
    }

    @Operation(summary = "添加工单回复记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody OaTaskRecord oaTaskRecord) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          oaTaskRecord.setUserId(loginUser.getUserId());
        }
        if (oaTaskRecordService.save(oaTaskRecord)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @Operation(summary = "修改工单回复记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody OaTaskRecord oaTaskRecord) {
        if (oaTaskRecordService.updateById(oaTaskRecord)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @Operation(summary = "删除工单回复记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (oaTaskRecordService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @Operation(summary = "批量添加工单回复记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<OaTaskRecord> list) {
        if (oaTaskRecordService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @Operation(summary = "批量修改工单回复记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<OaTaskRecord> batchParam) {
        if (batchParam.update(oaTaskRecordService, "task_record_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @Operation(summary = "批量删除工单回复记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (oaTaskRecordService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
